%
% FSK modulation testing - A. Macikunas, Waves in Space Corp.
% May 2017
%
runcode = 0;

if( runcode == 1),
    freqsep = 8;  % Frequency separation (Hz)
    nsamp = 8;    % Number of samples per symbol
    Fs = 32;      % Sample rate (Hz)
    % Generate random M-ary symbols.
    M = 4;        % Modulation order
    freqsep = 700;  % Frequency separation (Hz)
    nsamp = 8;    % Number of samples per symbol
    Fs = 9600;      % Sample rate (Hz)
    % Generate random M-ary symbols.
    
    x = randi([0 M-1],1000,1);
    % Apply FSK modulation.
    
    phase_cont = 'cont';
    symbol_order = 'grey';
    
    y = fskmod( x,M,freqsep,nsamp,Fs, phase_cont );
    % Create a spectrum analyzer System object? and use its step method to display a plot of the signal spectrum.
    
    figure(200); plot(real(y(1:200)),'k')
    figure(201); plot(180/pi*unwrap(angle(y(1:200))),'.')
    
    h = dsp.SpectrumAnalyzer('SampleRate',Fs);
    
    step(h,y)
    
else
    
    % Set the simulation parameters.
    
    M = 2;         % Modulation order
    k = log2(M);   % Bits per symbol
    EbNo = 5;      % Eb/No (dB)
    Fs = 16;       % Sample rate (Hz)
    nsamp = 8;     % Number of samples per symbol = oversampling rate, OS
    freqsep = 10;  % Frequency separation (Hz)
    
    %  Arunas parameters
    M = 16;         % Modulation order
    k = log2(M);   % Bits per symbol
    EbNo = 5;      % Eb/No (dB)
    Fs = 96000;       % Sample rate (Hz)
    nsamp = 8;     % Number of samples per symbol
    freqsep = 3000;  % Frequency separation (Hz)
    % Generate random data symbols.
    
    data = randi([0 M-1],5000,1);
    % Apply FSK modulation.
    
    txSig = fskmod(data,M,freqsep,nsamp,Fs);
    % Pass the signal through an AWGN channel
    
    rxSig  = awgn(txSig,EbNo+10*log10(k)-10*log10(nsamp),...
        'measured',[],'dB');
    % Demodulate the received signal.
    
    dataOut = fskdemod(rxSig,M,freqsep,nsamp,Fs);
    % Calculate the bit error rate.
    
    [num,BER] = biterr(data,dataOut);
    % Determine the theoretical BER and compare it to the estimated BER. Your BER value might vary because the example uses random numbers.
    
    figure(50); plot(real(txSig),'.'); hold on; plot(real(rxSig),'.'); hold off; grid
    figure(51); plot( 20*log10(abs(fftshift(fft(txSig)))),'.');
    BER_theory = berawgn(EbNo,'fsk',M,'noncoherent');
    
    [BER BER_theory]
    
end