function [syms, map_ind] = pi4qpskMapper(bits, map_ind)
% pi/4qpsk modulate
% mapping as defined in VDES standard
bps = 2;
max_map_ind = 2;
syms = complex(zeros(1,length(bits)/bps));
sym_ind = 1;

for bit_ind=1:bps:length(bits)
    bitGrp = bits(bit_ind:bit_ind+bps-1);
    
    switch map_ind
      case 0
        % The "usual" QPSK constellation    
        if(isequal(bitGrp, [0 0]))
          sym = (-sqrt(2)-j*sqrt(2))/2;
        elseif(isequal(bitGrp, [0 1]))
          sym = (-sqrt(2)+j*sqrt(2))/2;
        elseif(isequal(bitGrp, [1 1]))
          sym = (sqrt(2)+j*sqrt(2))/2;
        else
          sym = (sqrt(2)-j*sqrt(2))/2;
        % endif
        end
      case 1
        % The rotated QPSK constellation    
        if(isequal(bitGrp, [0 0]))
          sym = -1;
        elseif(isequal(bitGrp, [0 1]))
          sym = j;
        elseif(isequal(bitGrp, [1 1]))
          sym = 1;
        else
          sym = -j;
        %endif
        end
      otherwise
        error('Invalid map_ind value!')      
    %endswitch
    end
    map_ind = mod(map_ind + 1, max_map_ind);
    
    syms(sym_ind) = sym;
    sym_ind = sym_ind + 1;
end

end

