function syms = qpskMapperJan(bits)
% pi/4qpsk modulate
% mapping as defined in VDES standard
bps = 2;
syms = [];
sym_ind = 1;

for bit_ind=1:bps:length(bits)
    bitGrp = bits(bit_ind:bit_ind+bps-1);
    
    % The "usual" QPSK constellation
    if(bitGrp==[0 0])
      sym = (-sqrt(2)-j*sqrt(2))/2;
    elseif(bitGrp==[0 1])
      sym = (-sqrt(2)+j*sqrt(2))/2;
    elseif(bitGrp==[1 1])
      sym = (sqrt(2)+j*sqrt(2))/2;
    else
      sym = (sqrt(2)-j*sqrt(2))/2;
    end
    
    syms(sym_ind) = sym;
    sym_ind = sym_ind + 1;
end

end

